

#ifndef TDL_STRING_BUFFER
#define TDL_STRING_BUFFER

  /* We need some standard defintions, which used to come from stdtypes.H
   * However, these have been supplanted by other definitions in tcm.h...
   * Note: _TDL_INTERNAL_ may be have been set elsewhere, in which case
   *       we need to keep it set.
   */
#ifndef _TDL_INTERNAL_
#define _TDL_INTERNAL_
#define _TDL_UNDEF_INTERNAL_STRING_BUFFER
#endif

#include "tdl.H"

#ifdef _TDL_UNDEF_INTERNAL_STRING_BUFFER
#undef _TDL_UNDEF_INTERNAL_ACTION_OR_VOID
#undef _TDL_INTERNAL_
#endif


class TDL_StringBuffer
{
protected:
  ostrstream  streamBuffer;

public:
  TDL_StringBuffer() {}
  virtual ~TDL_StringBuffer();

  ostrstream & getInternalOstrstreamObject() { return streamBuffer; }

  TDL_StringBuffer & operator << ( int4         theInt    )
	{ getInternalOstrstreamObject() << theInt;    return *this; }
  TDL_StringBuffer & operator << ( const char * theString )
	{ getInternalOstrstreamObject() << theString; return *this; }

	/* Implies "freeze" -- string will not change again until unfreeze() */
  operator STRING ()
	{ return STRING(getInternalOstrstreamObject() . str()); }

	/* Allow the internal string to be changed / reallocated / destroyed */
  void unfreeze()
	{ getInternalOstrstreamObject() . freeze ( 0 ); }
};

/*
 * Some compilers may need these functions external to the class.
 * Red Hat 6.2 (egcs-2.91.66) does not..
 */
#ifdef TDL_STRING_BUFFER_NEEDS_OPERATOR_FUNCTIONS
inline TDL_StringBuffer &
operator << ( TDL_StringBuffer & theTdlStringBuffer, int4 theInt )
{
  return theTdlStringBuffer . operator << ( theInt );
}

inline TDL_StringBuffer &
operator << ( TDL_StringBuffer & theTdlStringBuffer, const char * theString )
{
  return theTdlStringBuffer . operator << ( theString );
}
#endif /* TDL_STRING_BUFFER_NEEDS_OPERATOR_FUNCTIONS */

#endif /* TDL_STRING_BUFFER */

