
/*
 * This is used as part of the generated RESUME functionality, so we can
 * keep track of what the current TCM Task is...  It's necessary for the
 * _TDL_INTERNAL_RESUME macro to work properly.
 */

#ifndef _TDL_BaseAction_H
#define _TDL_BaseAction_H

#include <tcm.h>

class _TDL_BaseAction : public _Action
{
protected:
	/* Note:  Intentionally not using a TCM_Task_Tree_Ref here to avoid *
	 * looping constructs that would inhibit garbage collection.        */
  Task_Tree_Node * tcmTaskTreeNodePointer;

public:
  _TDL_BaseAction()
    : tcmTaskTreeNodePointer ( (Task_Tree_Node *) NULL )
  {}

  virtual ~_TDL_BaseAction();

  Task_Tree_Node  * getTcmTaskTreeNode() const
					     { return tcmTaskTreeNodePointer; }

  _TDL_BaseAction * setTcmTaskTreeNode (
				  Task_Tree_Node * theTcmTaskTreeNodePointer )
		        { tcmTaskTreeNodePointer = theTcmTaskTreeNodePointer;
			  return this; }

  void clearTcmTaskTreeNode() { setTcmTaskTreeNode ((Task_Tree_Node *)NULL); }
};

#endif /* _TDL_BaseAction_H */

